/*jslint node: true */
"use strict";

module.exports=
{
	initialize: function(api, next)
	{
		api.log("ah-tdp-acl-plugin initialiser: Started...", "debug");


		// TMP	
		var path=require("path");
		var AHTDPACL=require(path.join(__dirname, "../ah-tdp-acl-plugin.js"));
		// var AHTDPACL=require("ah-tdp-acl-plugin");


		var tdpahacl=new AHTDPACL(api);

		api.actions.addPreProcessor(function(connection, actionTemplate, next)
		{
			api.log("ah-tdp-acl-plugin (preProcessor): Getting user role", "debug");

			tdpahacl.getUserRole(connection, function(err, userRole)
			{
				if(err) // If we can't successfully get a user role, we'll fail here as this is safest
				{
					api.log(err, "error");
					return next(connection, false);
				}
				else
				{
					api.log("ah-tdp-acl-plugin (preProcessor): Running ACL for role: "+userRole+" on action "+actionTemplate.name+" (@version "+actionTemplate.version+")", userRole, actionTemplate.name, actionTemplate.version, "info");	

					tdpahacl.roleHasPermissionsOnAction(userRole, actionTemplate.name, actionTemplate.version, function AHTDPACLRoleHasPermissionsOnAction(roleAllowed)
					{
						if(roleAllowed)
						{
							api.log("ah-tdp-acl-plugin (preProcessor): Permission granted on action "+actionTemplate.name+" (@version "+actionTemplate.version+") to role "+userRole, "info");

		// Need to do this properly
		connection.response.permission="Allowed";						
							return next(connection, true);
						}
						else
						{
							api.log("ah-tdp-acl-plugin (preProcessor): Permission denied on action "+actionTemplate.name+" (@version "+actionTemplate.version+") to role "+userRole, "info");

		// Need to do this properly
		connection.response.permission="Denied";						
							return next(connection, false);
						}
					});
					
				}
			});	
		});


		api.log("ah-tdp-acl-plugin initialiser: Done!", "debug");

		next();
	},
	start: function(api, next)
	{
		next();
	},
	stop: function(api, next)
	{
		next();
	}
}