/*jslint node: true */
"use strict";

process.env.NODE_ENV = 'test';

var should = require('should');
var actionheroPrototype = require('actionhero').actionheroPrototype;
var actionhero = new actionheroPrototype();
var api;


describe('actionhero plugin ah-tdp-acl-plugin tests', function()
{

  before(function(done)
  {
    actionhero.start(function(err, a)
    {
      api = a;
      done();
    })
  });

  after(function(done)
  {
    actionhero.stop(function(err)
    {
      done();
    });
  })

  it("Should allow the default (public) role to call ah-tdp-acl-plugin/testActionOne", function(done)
  {
      api.specHelper.runAction('ah-tdp-acl-plugin/testActionOne', {}, function(response, connection)
      {
        response.permission.should.eql("Allowed");
        return done();
      });
  });

  it("Should allow the default (public) role to call ah-tdp-acl-plugin/testActionTwo", function(done)
  {
      api.specHelper.runAction('ah-tdp-acl-plugin/testActionTwo', {}, function(response, connection)
      {
        response.permission.should.eql("Allowed");
        return done();
      });
  });


  it("Should deny the default (public) role when calling ah-tdp-acl-plugin/testActionThree", function(done)
  {
      api.specHelper.runAction('ah-tdp-acl-plugin/testActionThree', {}, function(response, connection)
      {
        response.permission.should.eql("Denied");
        return done();
      });
  });

  it("Should deny the default (public) role when calling ah-tdp-acl-plugin/testActionFour", function(done)
  {
      api.specHelper.runAction('ah-tdp-acl-plugin/testActionFour', {}, function(response, connection)
      {
        response.permission.should.eql("Denied");
        return done();
      });
  });


});